﻿Option Strict On

Imports System.Collections.Specialized
Imports System.ComponentModel
Public Class MetroTileControl : Inherits UserControl
  Private _Tiles As New Collections.ObjectModel.ObservableCollection(Of Panel)

  <Browsable(True)>
  <Description("A collection of all Tiles")>
  <DesignerSerializationVisibility(DesignerSerializationVisibility.Content)>
  Public Property Tiles() As Collections.ObjectModel.ObservableCollection(Of Panel)
    Get
      Return _Tiles
    End Get
    Set(ByVal value As Collections.ObjectModel.ObservableCollection(Of Panel))
      _Tiles = value
      UpdateList()
    End Set
  End Property

  Private Sub UpdateList()
    Controls.Clear()
    For i = 0 To _Tiles.Count - 1
      Me.Controls.Add(_Tiles(i))
      _Tiles(i).Width = Me.Width
      _Tiles(i).Height = Me.Height \ _Tiles.Count
      _Tiles(i).Left = 0
      _Tiles(i).Top = i * Me.Height \ _Tiles.Count
      _Tiles(i).Visible = True
    Next
  End Sub

  Private Sub InitializeComponent()
    Me.SuspendLayout()
    '
    'MetroTileControl
    '
    Me.Name = "MetroTileControl"
    Me.Size = New System.Drawing.Size(425, 349)
    Me.ResumeLayout(False)

  End Sub

  Private Sub UpdateList1(sender As Object, e As NotifyCollectionChangedEventArgs)
    UpdateList()
  End Sub

  Private Sub MetroTileControl_Resize(sender As Object, e As EventArgs) Handles Me.Resize
    Invalidate()
    UpdateList()
  End Sub

  Private Sub MetroTileControl_Load(sender As Object, e As EventArgs) Handles Me.Load
    AddHandler _Tiles.CollectionChanged, AddressOf UpdateList1
  End Sub
End Class